Get locations by query - Fabric

Get locations by query

cURL

curl --request POST \
  --url 'https://api.fabric.inc/v3/locations/search?limit=10' \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "sort": "-location.createdAt",
  "filters": [
    {
      "field": "location.locationNum",
      "value": "11245",
      "condition": "EQ"
    },
    {
      "field": "location.type",
      "values": [
        "DC",
        "STORE"
      ],
      "condition": "IN"
    }
  ]
}
'

Python

import requests

url = "https://api.fabric.inc/v3/locations/search?limit=10"

payload = {
    "sort": "-location.createdAt",
    "filters": [
        {
            "field": "location.locationNum",
            "value": "11245",
            "condition": "EQ"
        },
        {
            "field": "location.type",
            "values": ["DC", "STORE"],
            "condition": "IN"
        }
    ]
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (fetch)

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    sort: '-location.createdAt',
    filters: [
      {field: 'location.locationNum', value: '11245', condition: 'EQ'},
      {field: 'location.type', values: ['DC', 'STORE'], condition: 'IN'}
    ]
  })
};

fetch('https://api.fabric.inc/v3/locations/search?limit=10', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/locations/search?limit=10",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'sort' => '-location.createdAt',
    'filters' => [
        [
                'field' => 'location.locationNum',
                'value' => '11245',
                'condition' => 'EQ'
        ],
        [
                'field' => 'location.type',
                'values' => [
                                'DC',
                                'STORE'
                ],
                'condition' => 'IN'
        ]
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/locations/search?limit=10"

payload := strings.NewReader("{\n  \"sort\": \"-location.createdAt\",\n  \"filters\": [\n    {\n      \"field\": \"location.locationNum\",\n      \"value\": \"11245\",\n      \"condition\": \"EQ\"\n    },\n    {\n      \"field\": \"location.type\",\n      \"values\": [\n        \"DC\",\n        \"STORE\"\n      ],\n      \"condition\": \"IN\"\n    }\n  ]\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response Structure

{
  "pagination": {
    "limit": 10,
    "offset": 1,
    "count": 1000
  },
  "data": [
    {
      "locationNumber": 23,
      "name": "Seattle Store",
      "locationId": "9372919a8219e8",
      "isActive": true,
      "address": {
        "region": "WA",
        "addressLine1": 123,
        "addressLine2": "Suite 100",
        "addressLine3": "Seventh floor",
        "addressLine4": "Attention: Pat E. Kake",
        "city": "Seattle",
        "countryCode": "US",
        "postalCode": 98121,
        "type": "Home",
        "contacts": [
          {
            "type": "OFFICE",
            "email": "abc@mail.com",
            "phone": [
              {
                "number": "0281923712",
                "type": "MOBILE"
              }
            ],
            "name": {
              "firstName": "Pat",
              "middleName": "E",
              "lastName": "Kake"
            }
          }
        ]
      },
      "type": "DC",
      "capacity": {
        "maxAllocations": 30,
        "currentAllocations": 5,
        "infiniteAllocation": true,
        "allocationPercentage": 20,
        "isCapacityFull": true
      },
      "services": {
        "brand": "WHBM",
        "channel": "Frontline"
      },
      "zones": ["<string>"],
      "createdAt": "2022-05-25T07:58:30.996Z",
      "updatedAt": "2022-05-25T07:58:30.996Z",
      "operatingHours": [{
        "day": "SUNDAY",
        "hours": [{
          "open": 10,
          "close": 20,
          "type": "PICK_UP"
        }]
      }],
      "coordinates": {
        "type": "Point",
        "coordinates": [-122.3493, 47.6205]
      },
      "attributes": {
        "isReturns": "true"
      },
      "supportedCarriers": [{
        "carrier": "FedEx",
        "serviceLevels": [{
          "name": "FedEx",
          "shippingMethod": "FedEx"
        }]
      }],
      "activeFulfillmentMethods": {
        "ShipToHome": "true"
      },
      "transfer": {
        "isAutoReceiving": true,
        "autoStockWindow": "PT10M"
      }
    }
  ],
  "stats": ["<string>"]
}

Error Responses

{
  "type": "CLIENT_ERROR",
  "errorCode": "SERVICE-4003",
  "message": "Mandatory param(s): `requiredField1` is/are missing",
  "errors": [{
    "type": "CLIENT_ERROR",
    "errorCode": "SERVICE-4002",
    "message": "Invalid value(s) specified for 'requiredField.field3'",
    "errors": []
  }],
  "context": {
    "service": "orders",
    "endpoint": "POST /v3/orders"
  }
}
{
  "type": "CLIENT_ERROR",
  "errorCode": "SERVICE-4001",
  "message": "Unauthorized request",
  "errors": [],
  "context": {
    "service": "orders",
    "endpoint": "POST /v3/orders/OrderId_12345"
  }
}
{
  "type": "SERVER_ERROR",
  "errorCode": "SERVICE-5000",
  "message": "Internal server error",
  "errors": [],
  "context": {
    "service": "inventories",
    "endpoint": "POST /v3/inventories/actions/find-by-geography"
  }
}

Authorizations

Authorization: Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Headers